# Execute the test suite

export AWKPATH=.:..:$AWKPATH
rm _* 2> /dev/nul

echo "======== Starting csvmode tests ========"

# Mixed line endings: CR+lf, LF, CR
./test-csv.sh crlf -v BINMODE=1 -f csvdump.awk crlf.csv

# Mixed line endings, unterminated last line
./test-csv.sh crlf0 -v BINMODE=1 -f csvdump.awk crlf0.csv

# Convert the CSV delimiter
./test-csv.sh csvconvert -f csvconvert.awk csv.csv

# Rebuild a CSV file
./test-csv.sh csvformat -f csvformat.awk csvmode.csv

# Process with CSVMODE=0
./test-csv.sh csvmode0 -f csvmode0.awk csvmode.csv

# Process with CSVMODE=1
./test-csv.sh csvmode1 -f csvmode1.awk csvmode.csv

# Process with CSVMODE=-1
./test-csv.sh csvmode-1 -f csvmode-1.awk csvmode.csv

# Test csvparse()
./test-csv.sh csvsplit -f csvsplit.awk csv.csv

# Long CVS record, with many fields
./test-csv.sh manyfields -f csvdump.awk manyfields.csv

# CSV data with non-ASCII characters
./test-csv.sh nonascii -f csvdump.awk nonascii.csv

# Swith CSVMODE between files
./test-csv.sh switchmode -f switchmode.awk \
    comma.txt CSVMODE=-1 comma.txt CSVMODE=0 comma.txt \
    FPAT="[^\040,]+" comma.txt CSVMODE=-1 comma.txt CSVMODE=0 comma.txt \
    FIELDWIDTHS="1\0402\0403\0404" comma.txt CSVMODE=-1 comma.txt CSVMODE=0 comma.txt
    

echo "======== Done with csvmode tests ========"

COUNT=`ls _* 2>/dev/null | wc -l` ; \
	if test $COUNT = 0 ; \
	then	echo ALL TESTS PASSED ; \
	else	echo $COUNT TESTS FAILED ; exit 1; \
	fi

exit


switchmode::
	@echo $@
	@$(TEST_AWK) -f $(srcdir)/$@.awk comma.txt comma.csv comma.txt >_$@ 2>&1 || echo EXIT CODE: $$? >>_$@
	@-$(CMP) $(srcdir)/$@.ok _$@ && rm -f _$@

